import { APIError } from '@Models/GeneralTypes';
import {
  UserTokenInfo,
  UserSignInInfo,
  UserOAuthUrl,
  UserSignOutUrl,
} from '@Models/Redux/User/types';

export interface GetUserSingleSignInAPIPromise extends UserOAuthUrl {
  error?: APIError;
}
export interface PostUserRefreshAPIPromise extends UserTokenInfo {
  error?: APIError;
}
export interface GetUserAccountInfoAPIPromise extends UserSignInInfo {
  error?: APIError;
}
export interface PostUserSignOutAPIPromise extends UserSignOutUrl {
  error?: APIError;
}

export interface UserAPIProps {
  getUserSSO: (backUrl: string) => Promise<GetUserSingleSignInAPIPromise>;
  postUserRefreshToken: () => Promise<PostUserRefreshAPIPromise>;
  getUserAccountInfo: () => Promise<GetUserAccountInfoAPIPromise>;
  postUserSignOut: () => Promise<PostUserSignOutAPIPromise>;
}
