import React from 'react';
import { MessageSnackObject } from '@Models/Redux/Message/types';

export type ModalSize = 'xs' | 'sm' | 'md' | 'lg' | 'xl';

export interface ModalProps {
  open: boolean;
  onClose: () => void;
  onConfirm?: () => void;
  typeSize?: ModalSize;
  typeIsLoading?: boolean;
  disableEscapeKeyDown?: boolean;
  disableBackdropClick?: boolean;
  disableCancelButton?: boolean;
  disableConfirmButton?: boolean;
  confirmButtonText?: string;
  cancelButtonText?: string;
  tipsText?: React.ReactNode;
  children?: React.ReactNode;
  className?: string;
  mainName?: string;
  titleClassName?: string;
  actionClassName?: string;
  title?: React.ReactNode;
  closeIcon?: boolean;
  disabledConfirm?: boolean;
  blockLeave?: boolean;
  blockMessage?: MessageSnackObject;
}
