import React, { memo } from 'react';
import classNames from 'classnames';
import useDidMount from '@Hooks/useDidMount';
import useReduxApi from '@Hooks/useReduxApi';
import GifLoader from '@Components/Base/GifLoader';
import Styles from './index.module.css';

function AppCheckView(): React.ReactElement {
  /* Global & Local States */
  const reduxUser = useReduxApi('user');
  /* Functions */
  const initialize = (): void => {
    reduxUser('getUserIsLogin', []);
  };
  /* Hooks */
  useDidMount(() => {
    initialize();
  });
  /* Main */
  return <div className={classNames(Styles.appCheckViewContainer)}><GifLoader /></div>;
}

export default memo(AppCheckView);
