import Immerable from '@Models/GeneralImmer';
import cloneDeep from 'lodash/cloneDeep';
import { UserSignInInfo, UserAccountInfo, UserOAuthUrl } from './types';

class User extends Immerable {
  public userIsLogin: boolean;

  public userAuthCheck: boolean;

  public userAccount: UserSignInInfo;

  public userToken: string;

  public userOAuth: UserOAuthUrl;

  public constructor() {
    super();
    this.userIsLogin = false;
    this.userAuthCheck = true;
    this.userAccount = {
      account: {
        _id: '',
        username: '',
        email: '',
        display_name: '',
        createdAt: '',
        updatedAt: '',
      },
    };
    this.userToken = '';
    this.userOAuth = {
      url: '',
    };
  }

  public initialize(): void {
    this.userIsLogin = false;
    this.userAuthCheck = false;
    this.userAccount = {
      account: {
        _id: '',
        username: '',
        email: '',
        display_name: '',
        createdAt: '',
        updatedAt: '',
      },
    };
    this.userToken = '';
    this.userOAuth = {
      url: '',
    };
  }

  public updateUserLoginState(newUserLoginState: boolean): void {
    this.userIsLogin = newUserLoginState;
  }

  public updateUserAuthCheck(newUserAuthCheck: boolean): void {
    this.userAuthCheck = newUserAuthCheck;
  }

  public updateUserToken(newUserToken: string): void {
    this.userToken = cloneDeep(newUserToken);
  }

  public updateUserAccountInFo(newUserAccount: UserAccountInfo): void {
    this.userAccount.account = cloneDeep(newUserAccount);
  }

  public updateUserOAuthUrl(newUserOAuth: UserOAuthUrl): void {
    this.userOAuth = cloneDeep(newUserOAuth);
  }
}

export default User;
