import Message from '@Models/Redux/Message';
import MESSAGE_ACTION from '@Reducers/_Constants/Message';
import { MessageDialogObject, MessageConfirmObject } from '@Models/Redux/Message/types';
import { SetGlobalReduxResetAction } from '@Reducers/global/types';

export type MessageState = Message;

export interface CreateMessageReducerParams {
  initialState: MessageState;
}

export interface SetMessageContentInitialAction {
  type: MESSAGE_ACTION.SET_MESSAGE_INITIALIZE;
}

export interface SetMessageDialogAction {
  type: MESSAGE_ACTION.SET_MESSAGE_DIALOG;
  dialog: MessageDialogObject;
}

export interface RemoveMessageDialogAction {
  type: MESSAGE_ACTION.REMOVE_MESSAGE_DIALOG;
}

export interface SetMessageConfirmAction {
  type: MESSAGE_ACTION.SET_MESSAGE_CONFIRM;
  confirm: MessageConfirmObject;
}

export interface RemoveMessageConfirmAction {
  type: MESSAGE_ACTION.REMOVE_MESSAGE_CONFIRM;
}

export type MessageActionTypes =
  | SetMessageContentInitialAction
  | SetMessageDialogAction
  | RemoveMessageDialogAction
  | SetMessageConfirmAction
  | RemoveMessageConfirmAction
  | SetGlobalReduxResetAction;

export { MessageDialogObject, MessageConfirmObject };
