import jsonwebtoken from 'jsonwebtoken';
import { JWTToken } from './types';

export const delay = (ms: number): Promise<number> => {
  const range = 30; // JS settimeout時間稍微不準, 故多給一些範圍, 有些許容錯空間
  return new Promise((resolve) => {
    setTimeout(resolve, ms + range);
  });
};
export const getIsJwtToken = async (jwtToken: string): Promise<boolean> => {
  const data = jsonwebtoken.decode(jwtToken);
  if (data && data.exp) {
    return true;
  }
  return false;
};
export const getIsJwtTokenExpire = async (jwtToken: string, expiredTime = 0): Promise<boolean> => {
  const data: JWTToken = jsonwebtoken.decode(jwtToken);
  if (data && data.exp) {
    return Date.now() - data.exp * 1000 > expiredTime;
  }
  return true;
};
export const getIsEmail = (email: string): boolean => {
  let isEmail = false;
  // eslint-disable-next-line no-useless-escape
  const regexEmail = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
  if (regexEmail.test(email)) {
    isEmail = true;
  }
  return isEmail;
};
